% *
% * Initialization
% *

function [x0,k,c,xa,ka,xd] = apop_init_nopy( dummy, p )

  % Steady state concentrations
  x0 = zeros(58,1);

  x0(1)  = 1000;
  x0(2)  = 1000;
  x0(3)  = 0;
  x0(4)  = 0;
  x0(5)  = 2000;
  x0(6)  = 0;
  x0(7)  = 10000;
  x0(8)  = 0;
  x0(9)  = 0;
  x0(10) = 1000;
  x0(11) = 0;
  x0(12) = 10000;
  x0(13) = 0;
  x0(14) = 0;
  x0(15) = 10000;
  x0(16) = 0;
  x0(17) = 0;
  x0(18) = 0;
  x0(19) = 100000;
  x0(20) = 0;
  x0(21) = 1000000;
  x0(22) = 0;
  x0(23) = 0;
  x0(24) = 60000;
  x0(25) = 0;
  x0(26) = 0;
  x0(27) = 20000;
  x0(28) = 0;
  x0(29) = 80000;
  x0(30) = 0;
  x0(31) = 0;
  x0(32) = 0;
  x0(33) = 30000;
  x0(34) = 0;
  x0(35) = 0;
  x0(36) = 0;
  x0(37) = 0;
  x0(38) = 0;
  x0(39) = 500000;
  x0(40) = 0;
  x0(41) = 0;
  x0(42) = 500000;
  x0(43) = 0;
  x0(44) = 0;
  x0(45) = 100000;
  x0(46) = 0;
  x0(47) = 0;
  x0(48) = 0;
  x0(49) = 100000;
  x0(50) = 0;
  x0(51) = 0;
  x0(52) = 100000;
  x0(53) = 0;
  x0(54) = 0;
  x0(55) = 0;
  x0(56) = 0;
  x0(57) = 0;
  x0(58) = 0;


  % Rate constants
  k = zeros(115,1);

  k(1)  = 4E-7;    % k1
  k(2)  = 1E-6;    % k_1
  k(3)  = 1E-2;    % kc1
  k(4)  = 1E-6;    % k2
  k(5)  = 1E-3;    % k_2
  k(6)  = 1E-7;    % k3
  k(7)  = 1E-3;    % k_3
  k(8)  = 1   ;    % kc3
  k(9)  = 1E-6;    % k4
  k(10) = 1E-3;    % k_4
  k(11) = 1E-7;    % k5
  k(12) = 1E-3;    % k_5
  k(13) = 1   ;    % kc5
  k(14) = 1E-7;    % k6
  k(15) = 1E-3;    % k_6
  k(16) = 1   ;    % kc6
  k(17) = 1E-7;    % k7
  k(18) = 1E-3;    % k_7
  k(19) = 1   ;    % kc7
  k(20) = 2E-6;    % k8
  k(21) = 1E-3;    % k_8
  k(22) = 0.1 ;    % kc8
  k(23) = 1E-6;    % k9
  k(24) = 1E-3;    % k_9
  k(25) = 20   ;    % kc9
  k(26) = 1E-7;    % k10
  k(27) = 1E-3;    % k_10
  k(28) = 1   ;    % kc10
  k(29) = 1E-6;    % k11
  k(30) = 1E-3;    % k_11
  k(31) = 1E-7;    % k12
  k(32) = 1E-3;    % k_12
  k(33) = 1   ;    % kc12
  k(34) = 0.01 ;    % k13
  k(35) = 1 ;    % k_13
  k(36) = 1E-6;    % k14
  k(37) = 1E-3;    % k_14
  k(38) = 1E-6;    % k15
  k(39) = 1E-3;    % k_15
  k(40) = 1E-6;    % k16
  k(41) = 1E-3;    % k_16
  k(42) = 1E-6;    % k17
  k(43) = 1E-3;    % k_17
  k(44) = 1E-6;    % k18
  k(45) = 1E-3;    % k_18
  k(46) = 1E-6;    % k19
  k(47) = 1E-3;    % k_19
  k(48) = 1   ;    % kc19
  k(49) = 2E-6;    % k20
  k(50) = 1E-3;    % k_20
  k(51) = 10  ;    % kc20
  k(52) = 2E-6;    % k21
  k(53) = 1E-3;    % k_21
  k(54) = 10  ;    % kc21
  k(55) = 1 ;    % k22
  k(56) = 0.01 ;   % k_22
  k(57) = 5E-7;    % k23
  k(58) = 1E-3;    % k_23
  k(59) = 1   ;    % kc23
  k(60) = 5E-8;    % k24
  k(61) = 1E-3;    % k_24
  k(62) = 5E-9;    % k25
  k(63) = 1E-3;    % k_25
  k(64) = 1   ;    % kc25
  k(65) = 1 ;    % k26
  k(66) = 0.01 ;    % k_26
  k(67) = 2E-6;    % k27
  k(68) = 1E-3;    % k_27
  k(69) = 7E-6;    % k28
  k(70) = 1E-3;    % k_28
  
  mn_per_sec = 1/60;
  hr_per_sec = 1/3600;
  
  k(71) = 0.03854065;
  k(72) = -log(1/2)/1 * hr_per_sec;  % k72 - R  --(v72)->  null
  k(73) = 0.019286561;
  k(74) = -log(1/2)/1 * hr_per_sec;  % k74 - flip  --(v74)->  null
  k(75) = -log(1/2)/1 * hr_per_sec;  % flip-DISC  --(v75)->  null
  k(76) = 3.891984447;
  k(77) = -log(1/2)/1 * hr_per_sec;  % k77 - pC8  --(v77)->  null
  k(78) = 0.352860114;
  k(79) = -3*log(1/2)/1 * hr_per_sec;  % k79 - BAR  --(v79)->  null
  k(80) = -log(1/2)/0.1 * hr_per_sec;  % BAR-C8  --(v80)->  null;
  k(81) = 7.951575697;
  k(82) = -log(1/2)/1 * hr_per_sec;  % k82 - Bid  --(v82)->  null
  k(83) = 4.100758028; % Bcl2c synthesis
  k(84) = -log(1/2)/1 * hr_per_sec;
  k(85) = -log(1/2)/1 * hr_per_sec;  % tBid-Bcl2c  --(v85)->  null;
  k(86) = 20.02734316;
  k(87) = -log(1/2)/1 * hr_per_sec;  % k87 - Bax  --(v87)->  null
  k(88) = 277.2132759;
  k(89) = -log(1/2)/1 * hr_per_sec;  % k89 - Bcl2  --(v89)->  null
  k(90) = -log(1/2)/1 * hr_per_sec;  % Baxm-Bcl2  --(v90)->  null 
  k(91) = -log(1/2)/1 * hr_per_sec;  % Bax2-Bcl2  --(v91)->  null
  k(92) = -log(1/2)/1 * hr_per_sec;  % Bax4-Bcl2  --(v92)->  null
  k(93) = -log(1/2)/0.1 * hr_per_sec;  % AMito  --(v93)->  Mito
  k(94) = -log(1/2)/0.1 * hr_per_sec;  % Apaf*  --(v94)->  Apaf
  k(95) = 1155.349952;
  k(96) = -log(1/2)/1 * hr_per_sec;  % k96 - XIAP  --(v96)->  null
  k(97) = 1155.254105;
  k(98) = -log(1/2)/1 * hr_per_sec;  % k98 - mSmac  --(v98)->  null
  k(99) = -log(1/2)/1 * hr_per_sec;  % cSmac  --(v99)->  null 
  k(100) = -log(1/2)/1 * hr_per_sec;  % cSmac-XIAP  --(v100)->  null
  k(101) = 119.2737837;
  k(102) = -log(1/2)/1 * hr_per_sec;  % k102 - pC3  --(v102)->  null
  k(103) = -log(1/2)/1 * hr_per_sec;  % C3_U  --(v103)->  null
  k(104) = 115.7136783;
  k(105) = -log(1/2)/1 * hr_per_sec;  % k105 - pC6  --(v105)->  null
  k(106) = -log(1/2)/0.1 * hr_per_sec;  % C6  --(v106)->  null
  k(107) = -log(1/2)/1 * hr_per_sec;  % Apop-XIAP  --(v107)->  Apop
  k(108) = 192.8533213;
  k(109) = -log(1/2)/1 * hr_per_sec;  % k109 - Parp  --(v109)->  null
  k(110) = -log(1/2)/10 * mn_per_sec;  % cParp  --(v110)->  null
  k(111) = 0.001019175;
  k(112) = -log(1/2)/8 * hr_per_sec;  % L  --(v112)->  null
  k(113) = 96.27117545;
  k(114) = -log(1/2)/1 * hr_per_sec;  % k114 - mCytoC  --(v114)->  null
  k(115) = -log(1/2)/0.1 * hr_per_sec;  % cCytoC  --(v115)->  null
  
  k(1:115)=k(1:115)*60;  % per minute
  % Additional constants
  c = zeros(1,1);

  c(1) = 0.07;  % 1/mvol;  % mitochondria compartment volume/cell volume


  % Specie names
  xa = {'L'; ...	     % x1
    'R'; ...	     % x2
    'L-R'; ...     % x3
    'DISC'; ...	     % x4
    'flip'; ...	     % x5
    'flip-DISC'; ...     % x6
    'pC8'; ...	     % x7
    'DISC-pC8'; ...	     % x8
    'C8'; ...	     % x9
    'Bar'; ...	     % x10
    'Bar-C8'; ...	     % x11
    'pC3'; ...	     % x12
    'C8-pC3'; ...	     % x13
    'C3'; ...	     % x14
    'pC6'; ...	     % x15
    'C3-pC6'; ...	     % x16
    'C6'; ...	     % x17
    'C6-pC8'; ...	     % x18
    'XIAP'; ...    % x19
    'XIAP-C3'; ...	     % x20
    'PARP'; ...	     % x21
    'C3-PARP'; ...	     % x22
    'CPARP'; ...	     % x23
    'Bid'; ...	     % x24
    'C8-Bid'; ...	     % x25
    'tBid'; ...	     % x26
    'Mcl1'; ...	     % x27
    'Mcl1-tBid'; ...    % x28
    'Bax'; ...	     % x29
    'tBid-Bax'; ...	     % x30
    'act_Bax'; ...	     % x31
    'Baxm'; ...	     % x32
    'Bcl2'; ...	     % x33
    'Baxm-Bcl2'; ...     % x34
    'Bax2'; ...	     % x35
    'Bax2-Bcl2'; ...     % x36
    'Bax4'; ...	     % x37
    'Bax4-Bcl2'; ...     % x38
    'M'; ...	     % x39
    'Bax4-M'; ...	     % x40
    'AMito'; ...	     % x41
    'mCytoC'; ...	     % x42
    'AMito-mCytoC'; ...  % x43
    'ACytoC'; ...	     % x44
    'mSmac'; ...	     % x45
    'AMito-mSmac'; ...   % x46
    'ASmac'; ...	     % x47
    'CytoC'; ...	     % x48
    'Apaf'; ...	     % x49
    'Apaf-CytoC'; ...    % x50
    'act_Apaf'; ...	     % x51
    'pC9'; ...	     % x52
    'Apop'; ...	     % x53
    'Apop-pC3'; ...	     % x54
    'cSmac'; ...	     % x55
    'Apop-XIAP'; ...     % x56
    'cSmac-XIAP'; ...    % x57
    'C3_Ub' };     % x58



  % Reactions
  ka = {
    'L + R --(v1)-> L-R';
    'L-R --(v2)-> L + R';
    'L-R --(v3)-> DISC';
    'flip + DISC --(v4)-> flip-DISC ';
    'flip-DISC --(v5)-> flip + DISC';
    'pC8 + DISC --(v6)-> DISC-pC8';
    'DISC-pC8 --(v7)-> pC8 + DISC';
    'DISC-pC8 --(v8)-> C8 + DISC';
    'C8 + BAR --(v9)-> BAR-C8 ';
    'BAR-C8 --(v10)-> C8 + BAR';
    'pC3 + C8 --(v11)-> pC3-C8';
    'pC3-C8 --(v12)-> pC3 + C8';
    'pC3-C8 --(v13)-> C3 + C8';
    'pC6 + C3 --(v14)-> pC6-C3';
    'pC6-C3 --(v15)-> pC6 + C3';
    'pC6-C3 --(v16)-> C6 + C3';
    'pC8 + C6 --(v17)-> pC8-C6';
    'pC8-C6 --(v18)-> pC8 + C6';
    'pC8-C6 --(v19)-> C8 + C6';
    'XIAP + C3 --(v20)-> XIAP-C3';
    'XIAP-C3 --(v21)-> XIAP + C3';
    'XIAP-C3 --(v22)-> XIAP + C3_U';
    'PARP + C3 --(v23)-> PARP-C3';
    'PARP-C3 --(v24)-> PARP + C3';
    'PARP-C3 --(v25)-> CPARP + C3';
    'Bid + C8 --(v26)-> Bid-C8';
    'Bid-C8 --(v27)-> Bid + C8';
    'Bid-C8 --(v28)-> tBid + C8';
    'tBid + Mcl1 --(v29)-> tBid-Mcl1 ';
    'tBid-Mcl1 --(v30)-> tBid + Mcl1 ';
    'Bax + tBid --(v31)-> Bax-tBid';
    'Bax-tBid --(v32)-> Bax + tBid';
    'Bax-tBid --(v33)-> aBax + tBid ';
    'aBax --(v34)-> MBax ';
    'MBax --(v35)-> aBax ';
    'MBax + Bcl2 --(v36)-> MBax-Bcl2 ';
    'MBax-Bcl2 --(v37)-> MBax + Bcl2 ';
    'MBax + MBax --(v38)-> Bax2';
    'Bax2 --(v39)-> MBax + MBax';
    'Bax2 + Bcl2 --(v40)-> MBax2-Bcl2 ';
    'MBax2-Bcl2 --(v41)-> Bax2 + Bcl2 ';
    'Bax2 + Bax2 --(v42)-> Bax4';
    'Bax4 --(v43)-> Bax2 + Bax2';
    'Bax4 + Bcl2 --(v44)-> MBax4-Bcl2 ';
    'MBax4-cl2 --(v45)-> Bax4 + Bcl2 ';
    'Bax4 + Mit0 --(v46)-> Bax4-Mito';
    'Bax4-Mit0 --(v47)-> Bax4 + Mito';
    'Bax4-Mit0 --(v48)-> AMito ';
    'AMito + mCytoC --(v49)-> AMito-mCytoC';
    'AMito-mCytoC --(v50)-> AMito + mCytoC';
    'AMito-mCytoC --(v51)-> AMito + ACytoC ';
    'AMito + mSMac --(v52)-> AMito-mSmac';
    'AMito-mSMac --(v53)-> AMito + mSmac';
    'AMito + mSMac --(v54)-> AMito + ASmac ';
    'ACytoC --(v55)-> cCytoC';
    'cCytoC --(v56)-> ACytoC';
    'Apaf + cCytoC --(v57)-> Apaf-cCytoC ';
    'Apaf-cCytoC --(v58)-> Apaf + cCytoC ';
    'Apaf-cCytoC --(v59)-> act_Apaf + cCytoC ';
    'Apaf* + Procasp9 --(v60)-> Apoptosome ';
    'Apoptosome --(v61)-> act_Apaf + Procasp9';
    'Apop + pC3 --(v62)-> Apop-pC3';
    'Apop-pC3 --(v63)-> Apop + pC3';
    'Apop-pC3 --(v64)-> Apop + C3 ';
    'ASmac --(v65)-> cSmac';
    'cSmac --(v66)-> ASmac';
    'Apop + XIAP --(v67)-> Apop-XIAP ';
    'Apop-XIAP --(v68)-> Apop + XIAP ';
    'cSmac + XIAP --(v69)-> cSmac-XIAP ';
    'cSmac-XIAP --(v70)-> cSmac + XIAP ';
    'null --(v71)-> R';
    'R --(v72)-> null';
    'null --(v73)-> flip';
    'flip --(v74)-> null';
    'flip-DISC --(v75)-> null';
    'null --(v76)-> pC8';
    'pC8 --(v77)-> null';
    'null --(v78)-> BAR';
    'BAR --(v79)-> null';
    'BAR-C8 --(v80)-> null';
    'null --(v81)-> Bid';
    'Bid --(v82)-> null';
    'null --(v83)-> Bcl2c';
    'Bcl2c --(v84)-> null';
    'tBid-Bcl2c --(v85)-> null';
    'null --(v86)-> Bax';
    'Bax --(v87)-> null';
    'null --(v88)-> Bcl2';
    'Bcl2 --(v89)-> null';
    'Baxm-Bcl2 --(v90)-> null';
    'Bax2-Bcl2 --(v91)-> null';
    'Bax4-Bcl2 --(v92)-> null';
    'AMito --(v93)-> Mito';
    'Apaf* --(v94)-> Apaf';
    'null --(v95)-> XIAP';
    'XIAP --(v96)-> null';
    'null --(v97)-> mSmac';
    'mSmac --(v98)-> null';
    'cSmac --(v99)-> null';
    'cSmac-XIAP --(v100)-> null';
    'null --(v101)-> pC3';
    'pC3 --(v102)-> null';
    'C3_U --(v103)-> null';
    'null --(v104)-> pC6';
    'pC6 --(v105)-> null';
    'C6 --(v106)-> null';
    'Apop-XIAP --(v107)-> Apop';
    'null --(v108)-> Parp';
    'Parp --(v109)-> null';
    'cParp --(v110)-> null';
    'null --(v111)-> L';
    'L --(v112)-> null';
    'null --(v113)-> mCytoC';
    'mCytoC --(v114)-> null';
    'cCytoC --(v115)-> null'
  };

  % Specie delays
  xd = [];

end