function cell2csv(filename,cellArray)
% Writes cell array content into a *.csv file.
% 
% CELL2CSV(filename,cellArray,delimiter)
%
% filename      = Name of the file to save. [ i.e. 'text.csv' ]
% cellarray    = Name of the Cell Array where the data is in
% delimiter = seperating sign, normally:',' (default)
%
% by Sylvain Fiedler, KA, 2004
% modified by Rob Kohr, Rutgers, 2005 - changed to english and fixed delimiter
datei = fopen(filename,'w');
for z=1:size(cellArray,1)
    string = '';
    for s=1:size(cellArray,2)
        var = eval(['cellArray{z,s}']);

        if size(var,1) == 0
            var = '';
        end

        if isnumeric(var) == 1
            var = num2str(var);
        end
        
        if s == size(cellArray,2)
            string=strcat(string,var);
        else
            string=strcat(string,var,',');
            
        end
    end
    fprintf(datei,'%s\n',string);
end
fprintf(datei,'%s',string);
fclose(datei);