function run_cells_combined
    close all;
    clear all;
    %
    %This function initializes a bunch of cells, runs them until an event
    %(division or death) and then stops after some amount of time has passed
    %

    %%%%%%% LETS KEEP A QUEUE OF ALL CELLS TO BE RUN

    % Need to keep track of a cells current age, current time (cumulative
    % age)

    % We have 58 species for the apoptosis model
    % We have 23 species for the cell cycle model
    % We have 

    %Lets assume some number of maximum divisions (limits the fold increase to
    %256
    maxGens = 9;

    %maximum time for simulations
    maxTime=144*60;  % minutes



    N=100;  % starting cells
    %L=1000;  % death ligand  %%% 500 ~ 1% surival, 490 ~ 10% survival, 470 ~ 1/3 survival without stimulation, 430, ~ 100% survival
    

     % NFKB_CYCD_T NFKB_BCL2_T  NFKB_MYC_T    GROWTH_T  
     % RATE_CV CONC_CV PARTITION_CV VOL_CV IKK_CV  
     %GMSyn  GMDeg  MassGrowth MassDecay 
     % CYCDtDeg BCL2tDeg MYCDeg L mMycDeg 
     % IKK STIMULUS 7= CpG250 8=CpG10 which is shorter
              
    parameters=[40;40;40;40;         % CYCDT BCLT MYCT GROWT
        0.1;0.25;0.07 ;0.05 ; 0.25 ;    % RCV CCV PCV VCV IKKCV
        0.002; 0.0002 ;0.004; 0.002;     % GMSyn GMDeg MGrow MDeg
        
        0.0030;0.002;13;0.007;            % CYCDtSyn CYCDtDeg BCL2tSyn BCL2tDeg 
        0.0040;0.0020;1;0.0231;1;         % MYCSyn MYCDeg mMycSyn mMycDeg L
        1;1;10;1];                         % IKK Fxn, Crel?,cRelFbck,EPS (ribosomes)  
       

% constant stimulus since unbound ligand is outside the cell
    %c = clock
    %%%%%%%%%%%%% CELL %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % x_apop contains all species concentrations for apoptosis (at birth)
    % x_cc contains all species concentrations for cell cycle (at birth)
    % birthday is the time after the start of the simulation at which this cell
    %   came into being
    % fateday is the time after the start of the simulation at which the cell
    %   died or divided
    % fate is the fate of the cell 0 = nothing, 1= division, 2=death
    % gen the generation of this cell
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    
    % now lets run all of the cells repeatedly and 
    
    doOriginalCellCycle = 0;
    doMycCellCycle = 1;
    doNFkB = 0;
    doApoptosis = 0;
              
    if doOriginalCellCycle ==1
        resultOrigDiv = sampleDiv(N);
        saveInvertedCSV('OriginalMasses.csv',resultOrigDiv.xs,15,maxTime); 
        csvwrite('TdivsOrig.csv',resultOrigDiv.values');
    end
    if doMycCellCycle ==1
        resultDiv = sampleDivDieNFkB(1,N,parameters,maxTime,maxGens);
        saveInvertedCSV('SampledMasses.csv',resultDiv.xs,134,maxTime);
        saveInvertedCSV('cyclinA.csv',resultDiv.xs,120,maxTime);
        saveInvertedCSV('cyclinB.csv',resultDiv.xs,121,maxTime);
        saveInvertedCSV('cyclinD.csv',resultDiv.xs,122,maxTime);
        saveInvertedCSV('cyclinE.csv',resultDiv.xs,123,maxTime);
        saveInvertedCSV('cdh1.csv',resultDiv.xs,126,maxTime);
        saveInvertedCSV('MYC.csv',resultDiv.xs,143,maxTime);
        csvwrite('Tdivs.csv',resultDiv.values');
    end
    if doApoptosis ==1
        resultDie = sampleDivDieNFkB(2,N,parameters,maxTime,maxGens);
        saveInvertedCSV('CPARP.csv',resultDie.xs,84,maxTime);
        saveInvertedCSV('BclXL.csv',resultDie.xs,94,maxTime);
        csvwrite('Tdies.csv',resultDie.values');
    end
    if doNFkB == 1
        resultNFkB = sampleDivDieNFkB(3,N,parameters,maxTime,maxGens);
        saveInvertedCSV('A50n.csv',resultNFkB.xs,33,maxTime);
        saveInvertedCSV('C50n.csv',resultNFkB.xs,53,maxTime);
        saveInvertedCSV('IKKProfiles.csv',resultNFkB.IKK,1,maxTime);
    end
%     
%     figure(1);  
%     hold on;
%     for i = 1: numel(resultDiv.xs)
%        plota(1/60:(1/60):numel(resultDiv.xs{i}(:,134))/60,resultDiv.xs{i}(:,134)',0.2,'b');
%     end
%     figure(2);
%     hist(resultDiv.values,0:1:24);
%     
%     resultDie = sampleDivDieNFkB(2,N,parameters,maxTime,maxGens);
%     figure(3);  
%     hold on;
%     for i = 1: numel(resultDie.xs)
%        plota(1/60:(1/60):numel(resultDie.xs{i}(:,84))/60,resultDie.xs{i}(:,84)',0.2);
%     end
%     figure(4);
%     hist(resultDie.values,0:5:150);
%     
%     resultNFkB = sampleDivDieNFkB(3,N,parameters,maxTime,maxGens);
%     figure(5);  
%     hold on;
%     for i = 1: numel(resultNFkB.xs)
%        plota(1/60:(1/60):numel(resultNFkB.xs{i}(:,33))/60,resultNFkB.xs{i}(:,33)',0.2,'g');
%     end
%     figure(6);  
%     hold on;
%     for i = 1: numel(resultNFkB.xs)
%        plota(1/60:(1/60):numel(resultNFkB.xs{i}(:,53))/60,resultNFkB.xs{i}(:,53)',0.2,'r');
%     end
    
 %   matlabpool close;
end

function result=sampleDivDieNFkB(mode,N,parameters,maxTime,maxGens)
    cells = cell(N,1);
    %options=odeset('AbsTol',1E-6,'RelTol',1E-4,'Events',@divisionOrDeathNoStop);
    optionsDiv  = odeset('AbsTol',1E-5,'RelTol',1E-3,'Events',@divisionFullModel);
    parfor i=1:N  
        
        %%%%% RUN TO INITIALIZE THE PERSISTENT VARS %%%%%%%%%%
        experiment = randomCondition(maxTime,parameters);
        v = initial_parameters8(experiment);
        nfkbDivDeath_ode_cRelDisconnected([],[],[],v);
        v = getRandomCell(v);
        v.LOOKFOR = mode;
        v.SPECIES{1}(62) = 0; %L
        
        %initvalues(53) = 5;
        %%%%% RUN TO ACHIEVE STEADY STATE WITH BASAL SIGNALING ALSO ASSUME NO CELLCYCLE OR APOPTOSIS %%%%%%%%%%%%%%
        dcount = 0;
        v.activated = false;
        
        [t,x,te,ye,ie]=ode15s(@(t,x) nfkbDivDeath_ode_cRelDisconnected(t,x,[],v), [0 48*60], v.SPECIES{1},optionsDiv);
        if ie ==1
            %division occurred
            x(end,(numel(v.SPECIES{1})-v.CELL_CYCLE+15))=x(end,(numel(v.SPECIES{1})-v.CELL_CYCLE+15))/2;
            x(end,(numel(v.SPECIES{1})-v.CELL_CYCLE+13))=x(end,(numel(v.SPECIES{1})-v.CELL_CYCLE+13))/2;
            x(end,126)=1; % to avoid jumping back weirdness with cdh1
            dcount=dcount+1;
            if dcount > 1
                fprintf(1,'Extra division with tdiv=%f\n',t(end));
            end
        else

        v.SPECIES{1} = x(end,:);
        v.OUTPUT1 = [v.OUTPUT1;x];
        end
        %%%% AT THIS POINT WE SHOULD HAVE FINISHED UP EVERYTHING THAT WAS
        %%%% GOING ON AND EQUILIBRATED TO A QUIESCENT STATE
        v.activated = true;
        %%%% ACTIVATE THE CELL CYCLE AND APOPTOSIS PATHWAYS (NFkB STILL
        %%%% SEPERATE)
        v.SPECIES{1}(62) = experiment.L;
        cells{i}.v=v;
        cells{i}.v.PHASE = 2;
        cells{i}.x = cells{i}.v.SPECIES{1};
        %cell.x(49)=L;
        cells{i}.birthday=0;  % start at 0 hours
        cells{i}.gen = 1;  % undivided
        cells{i}.id =i;
        cells{i}.parent =0;
    end
    cell_id=N+1;
    result.values = {};
    result.xs = {};
    result.IKK = {};
    stridelength=ceil(length(cells)/100);
    fprintf(1,'\nProcessing %d cells\n',length(cells));
    for stride=1:stridelength
        celllength = min(100,length(cells)-(stride-1)*100);
        parfor temporary=((stride-1)*100+1):((stride-1)*100)+celllength                   
            cells{temporary}.v.SIM_TIME=max(1,(maxTime)-cells{temporary}.birthday);
            cells{temporary}.v.START_TIME = cells{temporary}.birthday;
            cells{temporary}.v.LOOKFOR = mode;
            cells{temporary}.v=run_cellUnrestricted(cells{temporary}.v);
            cells{temporary}.x = cells{temporary}.v.OUTPUT2(end,:);   % save the last concentrations
            cells{temporary}.xc = cells{temporary}.v.OUTPUT2;   % save the entire trajectory?
            cells{temporary}.short = cells{temporary}.v.SHORTOUTPUT;
        end
    end
    for c = 1:N        
        result.values{end+1}=cells{c}.v.SIM_TIME/60;
        result.xs{end+1} = cells{c}.xc;
        result.IKK{end+1} = (cells{c}.v.CURRENT_IKK*cells{c}.v.TOTAL_IKK)';
    end
    result.values = cell2mat(result.values);
end

function result=sampleDiv(N)
    cells = cell(N,1);
    %options=odeset('AbsTol',1E-6,'RelTol',1E-4,'Events',@divisionOrDeathNoStop);
    optionsDiv  = odeset('AbsTol',1E-5,'RelTol',1E-3,'Events',@division);

    parfor i=1:N  
        [x0,k,names] = getInitialCellCycle;
        %%%%% RUN TO INITIALIZE THE PERSISTENT VARS %%%%%%%%%%
        dcount = 0;
        [t,x,te,ye,ie]=ode15s(@(t,x) cellcycle_ode_1(t,x,k),[0 48*60],x0,optionsDiv);
        x(end,15) = x(end,15)/2;    % halve the mass
        x(end,13) = x(end,13)/2;    % halve the general machinery
        x(end,7) =1; % to avoid immediate division again

        %%%% AT THIS POINT WE SHOULD HAVE INTIALIZED
        cells{i}.x = x(end,:);
        cells{i}.birthday=0;  % start at 0 hours
        cells{i}.gen = 1;  % undivided
        cells{i}.id =i;
        cells{i}.parent =0;
    end
    cell_id=N+1;
    result.values = {};
    result.xs = {};
    stridelength=ceil(length(cells)/100);
    fprintf(1,'\nProcessing %d cells\n',length(cells));
    for stride=1:stridelength
        celllength = min(100,length(cells)-(stride-1)*100);
        parfor temporary=((stride-1)*100+1):((stride-1)*100)+celllength
            %introduce extrinsic protein variability
            %--- cell cycle syn/deg
            [x0,k,names] = getInitialCellCycle;
            k2 = k;
            for i = [1,2,5,7,8,9,12:15,18:34,47:67,74:76]
                k2(i)= max(0,normrnd(k(i),k(i)*.1));
            end
            %--- cell cycle species randomization
            theMask = zeros(23,1);
            theMask(17:22) = 1;
            cells{temporary}.x= getRandomSpeciesMaskLognormal(cells{temporary}.x,theMask,0.25,0);
            [t,x,te,ye,ie]=ode15s(@(t,x) cellcycle_ode_1(t,x,k2),[0 48*60],cells{temporary}.x,optionsDiv);
            cells{temporary}.xc = interp1(t, x(:,:),(0:1:t(end)));   % save the entire trajectory?
            cells{temporary}.lifespan = t(end);
        end
    end
    for c = 1:N        
        result.values{end+1}=cells{c}.lifespan;
        result.xs{end+1} = cells{c}.xc;
    end
    result.values = cell2mat(result.values);
end


function [kinit]=getRandomRatesMaskNormal(k0,mask,CV)
    kinit = zeros(length(k0),1);
    for cc=1:length(k0)
        factor = 1;
        if mask(cc) == 1
            factor = normrnd(1,double(sqrt(CV)));
        end
        kinit(cc)=factor*k0(cc);
    end
end

function [x0aa]= getRandomSpeciesMaskLognormal(x0,mask,CV,GaussianNoise)
    x0aa = zeros(length(x0),1);
    for cc=1:length(x0)
        factor = 1;
        if GaussianNoise > 0
            factor = normrnd(1,double(GaussianNoise));
        end
        
        if CV >0
            sigma = sqrt(log(CV*CV+1));
        else
            sigma = 0;
        end
        mu= log(max(0,x0(cc))); 
        if mask(cc) == 1
            rnd = lognrnd(mu,sigma);
            if mu==0 
                rnd=0;
            end
            x0aa(cc)=rnd*factor;
         
        else
            x0aa(cc)=x0(cc)*factor;
        end
    end
end

function v = getRandomCell(v)
        %--- Randomization of NFkB syn/deg params
        for i = [1,2,3,4,5,11,12,13,14]          
            for j = 1:size(v.pi(i,:),2)
                v.pi(i,j)=max(0,normrnd(v.pi(i,j),v.pi(i,j)*v.RATE_CV));
            end
        end
        for i = [1,2,3,4,5]         
            for j = 1:size(v.pm(i,:),2)
                v.pm(i,j)=max(0,normrnd(v.pm(i,j),v.pm(i,j)*v.RATE_CV));
            end
        end
        for i = 9:12          
            for j = 1:size(v.pd(i,:),2)
                v.pd(i,j)=max(0,normrnd(v.pd(i,j),v.pd(i,j)*v.RATE_CV));
            end
        end
        %--- apoptosis syn/deg
        for i = 71:115
            v.k(i)= max(0,normrnd(v.k(i),v.k(i)*v.RATE_CV));
        end
        %--- cell cycle syn/deg
        for i = [8,9,12:15,18:34,47:67,74:76,78:83]
            v.k2(i)= max(0,normrnd(v.k2(i),v.k2(i)*v.RATE_CV));
        end
        %--- cell cycle species randomization
        theMask = zeros(size(v.SPECIES{1},1),1);
        theMask(137:142) = 1;
        v.SPECIES{1} = getRandomSpeciesMaskLognormal(v.SPECIES{1},theMask,v.CONC_CV,0);
end

     % NFKB_CYCD_T NFKB_BCL2_T  NFKB_MYC_T    GROWTH_T  
     % RATE_CV CONC_CV PARTITION_CV VOL_CV IKK_CV  
     % GMSyn  GMDeg  MassGrowth MassDecay 
     % CYCDtSyn CYCDtDeg BCL2Syn BCL2tDeg 
     % MYCSyn MYCDeg mMycSyn mMycDeg L
     % IKK STIMULUS, Crel monomer,cRelFeedback,eps (Ribosome modifier)
function c2= randomCondition(maxTime,parameters)
    c2 = struct;
    c2.NFKB_CYCD_T= parameters(1);
    c2.NFKB_BCL2_T= parameters(2);
    c2.NFKB_MYC_T=  parameters(3);
    c2.GROWTH_T=    parameters(4);
    c2.RATE_CV=     parameters(5);
    c2.CONC_CV=     parameters(6);
    c2.PARTITION_CV=parameters(7);
    c2.VOL_CV=      parameters(8);
    c2.IKK_CV=      parameters(9);
    c2.GMSyn=       parameters(10);
    c2.GMDeg=       parameters(11);
    c2.MassGrowth=  parameters(12);
    c2.MassDecay=   parameters(13);
    c2.CYCDtSyn=    parameters(14);
    c2.CYCDtDeg=    parameters(15);
    c2.BCL2tSyn=    parameters(16);
    c2.BCL2tDeg=	parameters(17);
    c2.MYCSyn=      parameters(18);
    c2.MYCDeg=      parameters(19);
    c2.MYCtSyn=     parameters(20);
    c2.MYCtDeg=     parameters(21);
    c2.L=           parameters(22);
    c2.STIMULUS=    parameters(23);
    c2.CREL=        parameters(24);
    c2.cRelFeedback=parameters(25);
    c2.EPS=         parameters(26);
    c2.maxTime=maxTime;
end

function S=plota(x,y,alpha,color,width)
if nargin < 5
    width=1;
end
if nargin < 4
    color='k';
end
if nargin < 3
    alpha=0.2;
end
z = zeros(size(x));
S = surface([x;x],[y;y],[z;z],...
            'facecol','no',...
            'edgecol','interp',...
            'linew',width,...
            'edgealpha',alpha,...
            'edgecolor',color);
end

function saveInvertedCSV(filename, data, index, maxTime)
    f = fopen(filename,'w');
    for j = 1:10:maxTime-1
        writing=0;
        s='';
        for i= 1:numel(data)-1
           if j <= size(data{i},1) 
              s=sprintf('%s%4.3f,',s,data{i}(j,index));
              writing=1;
           else
              s=sprintf('%s,',s);
           end
        end
        if j <= size(data{end},1) 
           s=sprintf('%s%4.3f\n',s,data{end}(j,index));
           writing=1;
        else
           s=sprintf('%s\n',s);
        end
        if writing ==1
            fprintf(f,'%d,%s',j,s);
        else
            break;
        end
    end
    fclose(f);
end

